/* 
 * Copyright (c) 2006 NTT Data corporation.
 * All rights reserved.
 *
 * implemented by Daijiro MORI.
 *
 * derived from original pgsenna2.c developed by Daisuke Maki
 * (See below for copyright notice)
 * 
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose, without fee, and without a
 * written agreement is hereby granted, provided that the above
 * copyright notice and this paragraph and the following two
 * paragraphs appear in all copies.
 *
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE TO ANY PARTY FOR DIRECT,
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
 * LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
 * DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE AUTHOR SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS
 * IS" BASIS, AND THE AUTHOR HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE,
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 *
 */
/* $Id: pgsenna2.h 13 2006-01-01 12:25:53Z daisuke $
 *
 * Copyright (c) 2005 Daisuke Maki <dmaki@cpan.org>
 * All rights reserved.
 *
 * Development was funded by Brazil, Ltd. <http://b.razil.jp>
 * 
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose, without fee, and without a
 * written agreement is hereby granted, provided that the above
 * copyright notice and this paragraph and the following two
 * paragraphs appear in all copies.
 *
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE TO ANY PARTY FOR DIRECT,
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
 * LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
 * DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE AUTHOR SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS
 * IS" BASIS, AND THE AUTHOR HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE,
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 *
 */
#ifndef  __PGSENNA2_H__
#define  __PGSENNA2_H__

#include "access/itup.h"
#include "access/sdir.h"
#include "access/skey.h"
#include "access/xlog.h"
#include "utils/rel.h"

#include <senna.h>

#define PGS2_N_STRATEGIES		1
#define PGS2_LEFT_STRATEGY_NUMBER	1

#define PGS2_N_PROCS			1
#define PGS2_FILTER_PROC		1

#define PGS2_MAX_N_EXPRS		0x20
#define PGS2_MAX_N_INDEX_CACHE		0x10

extern Datum pgs2insert(PG_FUNCTION_ARGS);
extern Datum pgs2beginscan(PG_FUNCTION_ARGS);
extern Datum pgs2gettuple(PG_FUNCTION_ARGS);
extern Datum pgs2getmulti(PG_FUNCTION_ARGS);
extern Datum pgs2rescan(PG_FUNCTION_ARGS);
extern Datum pgs2endscan(PG_FUNCTION_ARGS);
extern Datum pgs2markpos(PG_FUNCTION_ARGS);
extern Datum pgs2restrpos(PG_FUNCTION_ARGS);
extern Datum pgs2build(PG_FUNCTION_ARGS);
extern Datum pgs2buildb(PG_FUNCTION_ARGS);
extern Datum pgs2bulkdelete(PG_FUNCTION_ARGS);
extern Datum pgs2costestimate(PG_FUNCTION_ARGS);
extern Datum pgs2contain(PG_FUNCTION_ARGS);
extern Datum pgs2nop(PG_FUNCTION_ARGS);
extern Datum pgs2getscore(PG_FUNCTION_ARGS);
extern Datum pgs2getnhits(PG_FUNCTION_ARGS);
extern Datum pgs2destroy(PG_FUNCTION_ARGS);

#endif   /* __PGSENNA2_H__ */
